明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1958|回复: 5

菜鸟求教:怎么指定“宽度因子”?

[复制链接]
发表于 2014-8-26 16:58:10 | 显示全部楼层 |阅读模式
各位好!

       我在程序里面指定了文字样式,可是发现“宽度因子”不对。我预设的文字样式“宽度因子”为0.7,但是我通过程序指定TextStyleId后发现“宽度因子”变成了1.0。怎么通过程序指定呢?

       谢谢啊!
发表于 2014-8-26 17:10:51 | 显示全部楼层
(defun c:kuu()
  (setq ent(entget (car (entsel))))
  (setq ge (getdist "\n输入文字宽度:"))
  (entmod (subst (cons 41 ge) (assoc 41 ent) ent))
  (princ)
  )
点选文字,直接改宽度
  
回复 支持 0 反对 1

使用道具 举报

发表于 2014-8-26 19:54:42 | 显示全部楼层
  1.         [CommandMethod("t2")]
  2.         public static void Test2()
  3.         {

  4.             using (var tr = new DBTransaction())
  5.             {
  6.                 var tsid = tr.TextStyleTable.Add("Test1", "gbenor.shx", "gbcbig.shx", 0.7);
  7.                 var btr = tr.OpenModelSpace();
  8.                 var tstr = tr.TextStyleTable["Test1"].GetObject<TextStyleTableRecord>(tr);

  9.                 var txt =
  10.                     new DBText
  11.                     {
  12.                         TextStyleId = tsid,
  13.                         TextString = "hello",
  14.                         Position = new Point3d(10,10,0),
  15.                         WidthFactor = 0.7,
  16.                     };

  17.                 tr.AddEntity(btr, txt);
  18.             }

  19.         }
发表于 2014-8-26 21:07:57 | 显示全部楼层
把你写的程序贴上来。
 楼主| 发表于 2014-9-5 10:59:41 | 显示全部楼层
我的代码:
Dim bt As BlockTable = trans.GetObject(dwg.BlockTableId, OpenMode.ForRead)
Dim btrMs As BlockTableRecord = trans.GetObject(bt(BlockTableRecord.ModelSpace), OpenMode.ForWrite)
Dim tst As TextStyleTable = trans.GetObject(dwg.TextStyleTableId, OpenMode.ForRead) '获取字体样式集合

Dim tech_req_pt As Point3d '插入点
                    
                        Dim Tech_req_head As MText = New MText()
                        Tech_req_head.Contents = "          技术要求"
                        Tech_req_head.TextHeight = 350
                        'Tech_req.SetAttachmentMovingLocation(AttachmentPoint.MiddleCenter)
                        tech_req_pt = New Point3d(sheet_pt(0) + sheet - 8000, sheet_pt(1) + 13850, 0)
                        Tech_req_head.Location = tech_req_pt
                        Tech_req_head.Layer = "JY"
                        Tech_req_head.ColorIndex = 81
                        Tech_req_head.TextStyleId = tst("HZ")‘该样式是已经制定好的
                        btrMs.AppendEntity(Tech_req_head)
                        trans.AddNewlyCreatedDBObject(Tech_req_head, True)
 楼主| 发表于 2014-9-5 11:00:32 | 显示全部楼层
雪山飞狐_lzh 发表于 2014-8-26 19:54

感谢飞狐!
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 12:43 , Processed in 0.169657 second(s), 25 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表